* getexectype.s - part of execd
*
* input - a0:execname address
*
* output- d0.l:type value(-????:no such file or can't exec , 0:normal, 0x03:.x)
*
* destroy - a0,d0

	.include doscall.mac

	.xdef	getexectype

	.cpu	68000

	.text
	.even

getexectype::

	link	a6,#-54
	movem.l	a1/a2,-(sp)

	move	#$a0,-(sp)
	pea	(a0)
	pea	(-54,a6)
	DOS	_FILES
	lea	(10,sp),sp
	tst.l	d0
	bmi	return		* file not found.

	suba.l	a1,a1
ext_check_loop:
	move.b	(a0)+,d0
	beq	ext_check
	cmpi.b	#'.',d0
	bne	ext_check_loop
	movea.l	a0,a1
	bra	ext_check_loop

ext_check:
	subq.l	#2,a0
	cmpa.l	a0,a1
	bne	exec_bit_check
	moveq	#$20,d0
	or.b	(a0),d0
	cmpi.b	#'x',d0
	beq	normal_file
	cmpi.b	#'r',d0
	beq	normal_file
	cmpi.b	#'z',d0
	beq	normal_file

exec_bit_check:
	move.b	(-54+21,a6),d0
	bpl	not_found

*can_exec_file:
	moveq	#3,d0

return:
	movem.l	(sp)+,a1/a2
	unlk	a6
	rts

normal_file:
	moveq	#0,d0
	bra	return

not_found:
	moveq	#-2,d0
	bra	return

	.end
