* exec2.s - part of execd
*
*   (a6).w..MD
*  2(a6).l..fil(command line)
*  6(a6).l..p1 (parameter buffer)
* 10(a6).l..p2 (environment pointer)


* Include File -------------------------------- *

	.include doscall.mac


* Global Symbol ------------------------------- *

	.xref	search_pathonly
	.xref	split
	.xref	checkexec
	.xref	execname_buf
	.xref	normal_exec

	.xref	searchpath
	.xref	no_current_search


* Text Section -------------------------------- *

	.cpu	68000

	.text
	.even

exec2::
	addq.l	#2,a6			* mode (skipped)
	movea.l	(a6)+,a2		* fil
	movea.l	(a6)+,a1		* p1
	movea.l	(a6)+,a3		* env
	movea.l	a2,a0

	bsr	split			* make p1

	lea	(execname_buf,pc),a0
	movea.l	a2,a1
	moveq	#0,d1
		move	#(256-2)-1,d2
execname_copy:				* make temporary basename
	move.b	(a1)+,d0
	move.b	d0,(a0)+
		dbeq	d2,execname_check
execname_last:
		beq	check_and_search
		lea	(-14,a6),a6
		bra	normal_exec
execname_check:
	bmi	kanji_check
	cmpi.b	#'/',d0
	beq	not_search
	cmpi.b	#'\',d0
	beq	not_search
	cmpi.b	#':',d0
	bne	execname_copy
not_search:
	moveq	#1,d1
	bra	execname_copy

kanji_check:
	cmpi.b	#$a0,d0
	bcs	is_kanji
	cmpi.b	#$e0,d0
	bcs	execname_copy
is_kanji:
	move.b	(a1)+,(a0)+
		dbeq	d2,execname_copy
		bra	execname_last

check_and_search:
	tst.l	d1
	bne	check_only
	move.b	(no_current_search,pc),d0
	bne	search_pathonly
	bra	searchpath

check_only:
	movea.l	a2,a0
	bra	checkexec

	.end

* End of File --------------------------------- *
